require "dotenv"
require "json"
require "active_record"
require "active_support"
require "active_support/all"
require "typhoeus"
require "yaml"
require "survey_monkey/config"
require "survey_monkey/version"
require "survey_monkey/request"
require "survey_monkey/auth"
require "survey_monkey/parameters"

module SurveyMonkey
  def self.request(options)
    Request.new(options)
  end
  
  def self.load_yaml_settings
    file = File.open API_SETTINGS_PATH
    settings = YAML.load file
    raise 'api_settings.yml NOT FOUND' if settings.nil? || settings.empty?
    settings
  end
  
  def self.method_missing(meth, *args, &block)
    settings = SurveyMonkey.load_yaml_settings
    settings.keys.each do |key|
      if ( key.to_s == meth.to_s )
        if args.empty? 
          return Request.new( Hash[api_method: meth] ) 
        else
          options = args.first
          options.merge!(Hash[api_method: meth])
          return Request.new(options)
        end
      end
    end
    super
  end
end
