module SurveyMonkey
  class Auth
    attr_reader :access_token, :api_key, :client_secret, :client_id
    def initialize(login = {})
      file_name = login[:dotenv_file_name] || SURVEY_MONKEY_DOTENV_PATH
      check_for_dotenv(file_name) unless env_vars_defined?

      @access_token   = login[:access_token]  || ENV['SURVEY_MONKEY_ACCESS_TOKEN']
      @api_key        = login[:api_key]       || ENV['SURVEY_MONKEY_API_KEY']
      @client_secret  = login[:client_secret] || ENV['SURVEY_MONKEY_CLIENT_SECRET']
      @client_id      = login[:client_id]     || ENV['SURVEY_MONKEY_CLIENT_ID']
    end
  private
    def check_for_dotenv(file_name)
      Dotenv.load!(file_name) if ( File.exists?(file_name) && Dotenv.respond_to?('load') )
    end

    def env_vars_defined?
      defined = false
      env_vars = ['SURVEY_MONKEY_ACCESS_TOKEN', 'SURVEY_MONKEY_API_KEY','SURVEY_MONKEY_CLIENT_SECRET','SURVEY_MONKEY_CLIENT_ID']
      env_vars.each do |var|
        defined = true if ENV.has_key?(var)
      end
      defined
    end
  end
end